package cn.ey.biz.module.system.service.field;

import cn.ey.biz.common.pojo.PageResult;
import cn.ey.biz.module.system.controller.admin.field.vo.*;
import cn.ey.biz.module.system.dal.dataobject.field.FieldDO;

import java.util.*;
import javax.validation.*;

/**
 * 字段权限-字段列表 Service 接口
 *
 */
public interface FieldService {

    /**
     * 创建字段权限-字段
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createField(@Valid FieldCreateReqVO createReqVO);

    /**
     * 更新字段权限-字段
     *
     * @param updateReqVO 更新信息
     */
    void updateField(@Valid FieldUpdateReqVO updateReqVO);

    /**
     * 删除字段权限-字段
     *
     * @param id 编号
     */
    void deleteField(Long id);

    /**
     * 获得字段权限-字段
     *
     * @param id 编号
     * @return 字段权限-字段
     */
    FieldDO getField(Long id);

    /**
     * 获得字段权限-字段列表
     *
     * @param ids 编号
     * @return 字段权限-字段列表
     */
    List<FieldDO> getFieldList(Collection<Long> ids);

    /**
     * 获得字段权限-字段分页
     *
     * @param pageReqVO 分页查询
     * @return 字段权限-字段分页
     */
    PageResult<FieldDO> getFieldPage(FieldPageReqVO pageReqVO);

    /**
     * 获得字段权限-字段列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 字段权限-字段列表
     */
    List<FieldDO> getFieldList(FieldExportReqVO exportReqVO);

    /**
     * 获得字段权限-字段列表
     *
     * @param exportReqVO 查询条件
     * @return 字段权限-字段列表
     */
    List<FieldRespVO> getFieldListWithBelongTo(FieldExportReqVO exportReqVO);

    List<FieldRespVO> getFieldListBelongTo(String configCode);

}
